// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.0
//
// <auto-generated>
//
// Generated from file `Metrics.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IceMX;

/**
 * Provides information on Glacier2 sessions.
 * 
 **/
public class SessionMetrics extends Metrics
{
    public SessionMetrics()
    {
        super();
        forwardedClient = 0;
        forwardedServer = 0;
        routingTableSize = 0;
        queuedClient = 0;
        queuedServer = 0;
        overriddenClient = 0;
        overriddenServer = 0;
    }

    public SessionMetrics(String id, long total, int current, long totalLifetime, int failures, int forwardedClient, int forwardedServer, int routingTableSize, int queuedClient, int queuedServer, int overriddenClient, int overriddenServer)
    {
        super(id, total, current, totalLifetime, failures);
        this.forwardedClient = forwardedClient;
        this.forwardedServer = forwardedServer;
        this.routingTableSize = routingTableSize;
        this.queuedClient = queuedClient;
        this.queuedServer = queuedServer;
        this.overriddenClient = overriddenClient;
        this.overriddenServer = overriddenServer;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new SessionMetrics();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::IceMX::Metrics",
        "::IceMX::SessionMetrics"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[2];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[2];
    }

    public static String ice_staticId()
    {
        return __ids[2];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, false);
        __os.writeInt(forwardedClient);
        __os.writeInt(forwardedServer);
        __os.writeInt(routingTableSize);
        __os.writeInt(queuedClient);
        __os.writeInt(queuedServer);
        __os.writeInt(overriddenClient);
        __os.writeInt(overriddenServer);
        __os.endWriteSlice();
        super.__writeImpl(__os);
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        forwardedClient = __is.readInt();
        forwardedServer = __is.readInt();
        routingTableSize = __is.readInt();
        queuedClient = __is.readInt();
        queuedServer = __is.readInt();
        overriddenClient = __is.readInt();
        overriddenServer = __is.readInt();
        __is.endReadSlice();
        super.__readImpl(__is);
    }

    /**
     * Number of client requests forwared.
     * 
     **/
    public int forwardedClient;

    /**
     * Number of server requests forwared.
     * 
     **/
    public int forwardedServer;

    /**
     * The size of the routing table.
     * 
     **/
    public int routingTableSize;

    /**
     * Number of client requests queued.
     * 
     **/
    public int queuedClient;

    /**
     * Number of server requests queued.
     * 
     **/
    public int queuedServer;

    /**
     * Number of client requests overridden.
     * 
     **/
    public int overriddenClient;

    /**
     * Number of server requests overridden.
     * 
     **/
    public int overriddenServer;

    public static final long serialVersionUID = 2992020973376844179L;
}
